#include "Ball.h"
#include "PhysicsElement.h"


int Ball::id=0;

Ball::Ball():PhysicsElement(id++),mass(1.0), radius(0.1),
             pos_t(0,0), speed_t(0,0){   // nobody can create a block without state
}

Ball::Ball(double mass, double radius, CVector position, CVector speed): 
            PhysicsElement(id++),mass(mass),radius(radius){
      pos_t = position;
      speed_t = speed;
}
double Ball::getRadius() const {
   return radius;
}
CVector Ball::getSpeed() const {
    return speed_t;
}
CVector Ball::getPosition() const {
    return pos_t;
}
double Ball::getMass() const {
    return mass;
}
void Ball::computeNextState(double delta_t, MyWorld * world) {
// you need to review, complete and/or change this code
  const PhysicsElement * pe;  // Assumption: on collision we only change speed.
  if ((pe=world->findCollidingBall(this))!= NULL){ /* elastic collision */
     const Ball* pb= dynamic_cast<const Ball*> (pe);
     if (pb !=NULL) {
       double massFactor = 2*pb->getMass()/(mass+pb->getMass());
     }     
  }
  pos_tPlusDelta = pos_t + speed_t*delta_t;
}
const PhysicsElement* Ball::collideWith(const Ball* pb) const { // it return itself 
                      // or a physical element which is part of it 
// you need to review and complete this code
   if (this == pb) return NULL;
   const Ball& b=*pb;
}
void Ball::updateState(){
     pos_t = pos_tPlusDelta;
     speed_t = speed_tPlusDelta;
}
string Ball::getDescription() const {
   return "Ball_" + std::to_string(getId())+":x,y";
}

string Ball::getState() const{
   return std::to_string(pos_t.getX())+","+std::to_string(pos_t.getY()); 
}

ostream & operator<< (ostream & os, const Ball & b) {
  os << b.pos_t;
  return os;
}